#!/usr/bin/env node
const colors = require('colors');
const yargs = require('yargs');
const process = require('process');

const cliOpt = require('../lib/config.json');
const package = require('../package.json');
const clone = require('./clone.js');
const create = require('./create.js');
const push = require('./push.js');
const argv = yargs.argv;

yargs.usage('Usage: $0 <command> [options]')
.command('clone', '克隆一个项目'.blue)
.command('create', '新建一个项目'.blue)
.command('push', '提交项目', function(args) {
    return yargs.option('m', {
        describe: '提交备注',
        demandOption: true
    });
})
.demandCommand(1, '缺少有效命令'.red)
.version('v', '开发框架版本号：', '开发框架：' + cliOpt.frame.version + ', comb-cli：' + package.version)
.example('$0 clone http://xxx.git')
.example('$0 init')
.help('h')
.argv;

const cmd = argv._[0];

switch (cmd) {
    case 'clone':
        const gitUrl = argv._[1];
        if (gitUrl) {
            clone(gitUrl);
        } else {
            echo('请输入有效的项目地址'.red);
        }
    break;
    case 'create':
        create();
    break;
    case 'push':
        push(argv.m);
    break;
    default:
    break;
}
